using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
			CategoryBuilder.Create("Cyber's World War Mod", "A category for world war era items.", ModAPI.LoadSprite("category.png"));
			//Nazi Germany
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Nazi Germany [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "\n<color=green>World War II (1939-1945)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("germany/ger_logo.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        GameObject.Destroy(Instance);
                    }
                }
            );
            //German Infantryman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "German Infantryman [CWWM]",
					NameToOrderByOverride = "g",
                    DescriptionOverride = "A German soldier bearing an M40 uniform." + "\n<color=green>World War II",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ger_inf.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var middlebody = Instance.transform.GetChild(5);
						
                        var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Equipment");
                        childObject.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        childObject.transform.localPosition = new Vector3(0, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("germany/ger_gear.png");

                        foreach (var limb in person.Limbs)
                        {
                            var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
                            HumanSprites.person = person;

                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/infantry/ger_inf1_1.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/infantry/ger_inf1_2.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/infantry/ger_inf1_3.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/infantry/ger_inf1_4.png"));

                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/infantry/ger_inf2_1.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/infantry/ger_inf2_2.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/infantry/ger_inf2_3.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/infantry/ger_inf2_4.png"));
                        };
                    }
                }
            );
            //German Combat Medic
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "German Combat Medic [CWWM]",
					NameToOrderByOverride = "g",
                    DescriptionOverride = "A German combat medic bearing an M40 uniform with several medical accessories." + "\n<color=green>World War II",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ger_med.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var middlebody = Instance.transform.GetChild(5);
						
                        var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Equipment");
                        childObject.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        childObject.transform.localPosition = new Vector3(0, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("germany/ger_gear.png");

                        foreach (var limb in person.Limbs)
                        {
                            var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
                            HumanSprites.person = person;

                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/medic/ger_med1.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/medic/ger_med2.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/medic/ger_med3.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/medic/ger_med4.png"));
                        };
                    }
                }
            );
            //German Tanker
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "German Tanker [CWWM]",
					NameToOrderByOverride = "g",
                    DescriptionOverride = "A German tanker bearing a panzer uniform." + "\n<color=green>World War II",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ger_tan.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        foreach (var limb in person.Limbs)
                        {
                            var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
                            HumanSprites.person = person;

                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/tanker/ger_tan1.png"));
                        };
                    }
                }
            );
            //German NCO
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "German NCO [CWWM]",
					NameToOrderByOverride = "g",
                    DescriptionOverride = "A German non-commissioned officer bearing an M40 uniform." + "\n<color=green>World War II",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ger_nco.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        foreach (var limb in person.Limbs)
                        {
                            var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
                            HumanSprites.person = person;

                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/nco/ger_nco1.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/nco/ger_nco2.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("germany/nco/ger_nco3.png"));
                        };
                    }
                }
            );
			//M40 Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "M40 Helmet [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German steel helmet." + "\n<color=green>World War II (1940)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ger_helmet.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/ger_helmet_collide.png");
					    
                        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(ColliderBoxDeleteVar);
                        }
                        Instance.FixColliders();
						
                        Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("germany/ger_helmet1.png"),
                            ModAPI.LoadSprite("germany/ger_helmet2.png"),
                        };
						
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
			//M40 Medic Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "M40 Medic Helmet [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German steel helmet with medical markings." + "\n<color=green>World War II (1940)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ger_med_helmet.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/ger_helmet_collide.png");
					    
                        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(ColliderBoxDeleteVar);
                        }
                        Instance.FixColliders();
						
                        Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("germany/ger_med_helmet1.png"),
                        };
						
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
			//M42 Infantry Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "M42 Infantry Cap [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German infantry cap made of wool." + "\n<color=green>World War II (1943)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ger_cap.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/ger_cap_collide.png");
					    
                        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(ColliderBoxDeleteVar);
                        }
                        Instance.FixColliders();
						
                        Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("germany/ger_cap1.png"),
                        };
						
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
			//M43 Field Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "M43 Field Cap [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German field cap made of wool." + "\n<color=green>World War II (1943)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ger_fcap.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/ger_fcap_collide.png");
					    
                        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(ColliderBoxDeleteVar);
                        }
                        Instance.FixColliders();
						
                        Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("germany/ger_fcap1.png"),
                            ModAPI.LoadSprite("germany/ger_fcap2.png"),
                        };
						
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
			//M40 Tanker Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "M40 Tanker Cap [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German tanker's cap made of wool." + "\n<color=green>World War II (1943)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ger_tcap.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/ger_tcap_collide.png");
					    
                        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(ColliderBoxDeleteVar);
                        }
                        Instance.FixColliders();
						
                        Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("germany/ger_tcap1.png"),
                        };
						
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
			//Officer Visor Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "German Officer Visor Cap [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German visor cap designated to officer ranks." + "\n<color=green>World War II (1938)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ger_ocap.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/ger_ocap_collide.png");
					    
                        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(ColliderBoxDeleteVar);
                        }
                        Instance.FixColliders();
						
                        Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("germany/ger_ocap1.png"),
                        };
						
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
			//Pak 40
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Detached 120mm Cannon"),
                    NameOverride = "Panzerabwehrkanone 40 [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German anti-tank gun." + "\n<color=green>World War II (1940)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/pak40.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/pak40_collide.png");
					    
                        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(ColliderBoxDeleteVar);
                        }
                        Instance.FixColliders();


                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Flammable Metal");
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 25f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 25f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 25f;
                        
                        Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("germany/pak40_1.png"),
                        };
                            var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/pak40.wav")
                        };
                    }
                }
            );
			//Tellermine 35
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Dynamite"),
                    NameOverride = "Tellermine 35 [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German anti-tank mine. Won't trigger under light pressure." + "\n<color=green>World War II (1935)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/tellermine.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/tellermine.png");
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Flammable metal");
						Instance.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 2f;
						Instance.GetComponent<ExplosiveBehaviour>().ArmOnUse = false;
						Instance.FixColliders();
                    }
                }
            );
			//Karabiner 98 kurz
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Karabiner 98 kurz [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German bolt-action rifle." + "\n<color=green>World War II (1935)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/kara.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/kara.png");
						Instance.FixColliders();
                          var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/kara.wav")
                        };
                    }
                }
            );
			//Maschinengewehr 42
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Light Machine Gun"),
                    NameOverride = "Maschinengewehr 42 [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German general-purpose machine gun." + "\n<color=green>World War II (1942)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/mg42.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/mg42.png");
						Instance.FixColliders();
						var firearm = Instance.GetComponent<FirearmBehaviour>();

						firearm.AutomaticFireInterval = 0.05f;
						firearm.InitialInaccuracy = 0.05f;
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/mg42.wav")
                        };
                    }
                }
            );
			//Maschinenpistole 40
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                    NameOverride = "Maschinenpistole 40 [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German submachine gun." + "\n<color=green>World War II (1940)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/mp40.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/mp40.png");
						Instance.FixColliders();
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						firearm.AutomaticFireInterval = 0.1f;
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/mp40.wav")
                        };
                    }
                }
            );
			//Walther P38
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "Walther P38 [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German semi-automatic pistol." + "\n<color=green>World War II (1938)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/p38.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/p38.png");
						Instance.FixColliders();
                          var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/p08.wav")
                        };
                    }
                }
            );
			//Luger P08
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "Luger P08 [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German semi-automatic pistol." + "\n<color=purple>WW1 & WW2 (1904)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/p08.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/p08.png");
						Instance.FixColliders();
                          var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/p08.wav")
                        };
                    }
                }
            );
			//Stielhandgranate 42
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stielhandgranate"),
                    NameOverride = "Stielhandgranate 42 [CWWM]",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A German anti-personnel stick grenade." + "\n<color=green>World War II (1942)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/shg42.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("germany/shg42.png");
						Instance.FixColliders();
                    }
                }
            );
			//Fascist Italy
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Fascist Italy [CWWM]",
                    NameToOrderByOverride = "i",
                    DescriptionOverride = "\n<color=green>World War II (1940-1943)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("italy/ita_logo.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        GameObject.Destroy(Instance);
                    }
                }
            );
            //Italian Infantryman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Italian Infantryman [CWWM]",
					NameToOrderByOverride = "i",
                    DescriptionOverride = "An Italian soldier bearing an M40 uniform." + "\n<color=green>World War II",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ita_inf.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var middlebody = Instance.transform.GetChild(5);
						
                        var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Equipment");
                        childObject.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        childObject.transform.localPosition = new Vector3(0, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("italy/ita_gear.png");

                        foreach (var limb in person.Limbs)
                        {
                            var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
                            HumanSprites.person = person;

                            HumanSprites.Textures.Add(ModAPI.LoadTexture("italy/infantry/ita_inf1.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("italy/infantry/ita_inf2.png"));
                        };
                    }
                }
            );
			//M33 Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "M33 Helmet [CWWM]",
                    NameToOrderByOverride = "i",
                    DescriptionOverride = "An Italian steel helmet." + "\n<color=green>World War II (1933)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ita_helmet.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("italy/ita_helmet_collide.png");
					    
                        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(ColliderBoxDeleteVar);
                        }
                        Instance.FixColliders();
						
                        Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("italy/ita_helmet1.png"),
                        };
						
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
			//M28 Pith Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "M28 Pith Helmet [CWWM]",
                    NameToOrderByOverride = "i",
                    DescriptionOverride = "An Italian pith helmet." + "\n<color=green>World War II (1928)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ita_pith.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("italy/ita_pith_collide.png");
					    
                        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(ColliderBoxDeleteVar);
                        }
                        Instance.FixColliders();
						
                        Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("italy/ita_pith1.png"),
                            ModAPI.LoadSprite("italy/ita_pith2.png"),
                        };
						
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
			//M42 Field Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "M1942 Field Cap [CWWM]",
                    NameToOrderByOverride = "i",
                    DescriptionOverride = "An Italian field cap made of wool." + "\n<color=green>World War II (1943)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/ita_cap.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("italy/ita_cap_collide.png");
					    
                        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(ColliderBoxDeleteVar);
                        }
                        Instance.FixColliders();
						
                        Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("italy/ita_cap1.png"),
                            ModAPI.LoadSprite("italy/ita_cap2.png"),
                        };
						
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
			//Carcano M1891
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Carcano M1891 [CWWM]",
                    NameToOrderByOverride = "i",
                    DescriptionOverride = "An Italian bolt-action rifle." + "\n<color=purple>WW1 & WW2 (1891)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/carcano.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("italy/carcano.png");
						Instance.FixColliders();
                          var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/carcano.wav")
                        };
                    }
                }
            );
			//Breda 30
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Soviet Submachine Gun"),
                    NameOverride = "Breda 30 [CWWM]",
                    NameToOrderByOverride = "i",
                    DescriptionOverride = "An Italian light machine gun." + "\n<color=green>World War II (1930)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/breda.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("italy/breda.png");
						Instance.FixColliders();
						var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
						firearm.AutomaticFireInterval = 0.10f;
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/bren.wav")
                        };
                    }
                }
            );
			//FNAB-43
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                    NameOverride = "FNAB-43 [CWWM]",
                    NameToOrderByOverride = "i",
                    DescriptionOverride = "An Italian submachine gun." + "\n<color=green>World War II (1943)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/fnab.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("italy/fnab.png");
						Instance.FixColliders();
						var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/mp40.wav")
                        };
                    }
                }
            );
			//Beretta M1934
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "Beretta M1934 [CWWM]",
                    NameToOrderByOverride = "i",
                    DescriptionOverride = "An Italian semi-automatic pistol." + "\n<color=green>World War II (1934)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/m1934.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("italy/m1934.png");
						Instance.FixColliders();
                          var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/m1911.wav")
                        };
                    }
                }
            );
			//SRCM Mod.35
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                    NameOverride = "SRCM Mod.35 [CWWM]",
                    NameToOrderByOverride = "i",
                    DescriptionOverride = "An Italian anti-personnel hand grenade." + "\n<color=green>World War II (1935)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/srcm.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("italy/srcm.png");
						Instance.FixColliders();
                    }
                }
            );
			//Great Britain
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Great Britain [CWWM]",
                    NameToOrderByOverride = "c",
                    DescriptionOverride = "\n<color=green>World War II (1939-1945)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("commonwealth/com_logo.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        GameObject.Destroy(Instance);
                    }
                }
            );
            //Commonwealth Infantryman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Commonwealth Infantryman [CWWM]",
					NameToOrderByOverride = "c",
                    DescriptionOverride = "A Commonwealth soldier bearing a P40 uniform." + "\n<color=green>World War II",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/com_inf.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var middlebody = Instance.transform.GetChild(5);
						
                        var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Equipment");
                        childObject.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        childObject.transform.localPosition = new Vector3(0, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("commonwealth/com_gear.png");

                        foreach (var limb in person.Limbs)
                        {
                            var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
                            HumanSprites.person = person;

                            HumanSprites.Textures.Add(ModAPI.LoadTexture("commonwealth/com_inf.png"));
                        }
                    }
                }
            );
			//Mk. II Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Mk. II Helmet [CWWM]",
                    NameToOrderByOverride = "c",
                    DescriptionOverride = "A British steel helmet." + "\n<color=purple>WW1 & WW2 (1915)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/com_helmet.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("commonwealth/com_helmet_collide.png");
					    
                        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(ColliderBoxDeleteVar);
                        }
                        Instance.FixColliders();
						
                        Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("commonwealth/com_helmet.png"),
                        };
						
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
			//Lee Enfield No.1 Mk.III
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Lee Enfield No.1 Mk.III [CWWM]",
                    NameToOrderByOverride = "c",
                    DescriptionOverride = "A British bolt-action rifle." + "\n<color=purple>WW1 & WW2 (1895)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/lee.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("commonwealth/lee.png");
						Instance.FixColliders();
                          var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/lee.wav")
                        };
                    }
                }
            );
			//Bren Mk.1
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Soviet Submachine Gun"),
                    NameOverride = "Bren Mk.1 [CWWM]",
                    NameToOrderByOverride = "c",
                    DescriptionOverride = "A British light machine gun." + "\n<color=green>World War II (1938)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/bren.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("commonwealth/bren.png");
						Instance.FixColliders();
						var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
						firearm.AutomaticFireInterval = 0.12f;
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/bren.wav")
                        };
                    }
                }
            );
			//Sten Mk.II
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                    NameOverride = "Sten Mk.II [CWWM]",
                    NameToOrderByOverride = "c",
                    DescriptionOverride = "A British submachine gun." + "\n<color=green>World War II (1941)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/sten.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("commonwealth/sten.png");
						Instance.FixColliders();
						var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/sten.wav")
                        };
                    }
                }
            );
			//Enfield No.2 Mk.1
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Revolver"),
                    NameOverride = "Enfield No.2 Mk.1 [CWWM]",
                    NameToOrderByOverride = "c",
                    DescriptionOverride = "A British service revolver." + "\n<color=green>World War II (1932)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/enfield.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("commonwealth/enfield.png");
						Instance.FixColliders();
                    }
                }
            );
			//No.36 Mk.1 "Mills Bomb"
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                    NameOverride = "No.36 Mk.1 'Mills Bomb' [CWWM]",
                    NameToOrderByOverride = "c",
                    DescriptionOverride = "A British anti-personnel hand grenade." + "\n<color=purple>WW1 & WW2 (1915)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/no36.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("commonwealth/no36.png");
						Instance.FixColliders();
                    }
                }
            );
			//The United States
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "The United States [CWWM]",
                    NameToOrderByOverride = "a",
                    DescriptionOverride = "\n<color=green>World War II (1941-1945)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("america/usa_logo.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        GameObject.Destroy(Instance);
                    }
                }
            );
            //American Infantryman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "American Infantryman [CWWM]",
					NameToOrderByOverride = "a",
                    DescriptionOverride = "An American soldier bearing an M41 uniform." + "\n<color=green>World War II",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/usa_inf.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var middlebody = Instance.transform.GetChild(5);
						
                        var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Equipment");
                        childObject.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        childObject.transform.localPosition = new Vector3(0, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("america/usa_gear.png");

                        foreach (var limb in person.Limbs)
                        {
                            var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
                            HumanSprites.person = person;

                            HumanSprites.Textures.Add(ModAPI.LoadTexture("america/infantry/usa_inf1.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("america/infantry/usa_inf2.png"));
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("america/infantry/usa_inf3.png"));
                        };
                    }
                }
            );
			//M1 Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "M1 Helmet [CWWM]",
                    NameToOrderByOverride = "a",
                    DescriptionOverride = "An American steel helmet." + "\n<color=green>World War II (1941)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/usa_helmet.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("america/usa_helmet_collide.png");
					    
                        foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
                        {
                        GameObject.Destroy(ColliderBoxDeleteVar);
                        }
                        Instance.FixColliders();
						
                        Instance.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("america/usa_helmet1.png"),
                            ModAPI.LoadSprite("america/usa_helmet2.png"),
                        };
						
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
			//M1 Bazooka
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bazooka"),
                    NameOverride = "M1 Bazooka [CWWM]",
                    NameToOrderByOverride = "a",
                    DescriptionOverride = "An American anti-tank rocket launcher." + "\n<color=green>World War II (1942)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/bazooka.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("america/bazooka.png");
						Instance.FixColliders();
                    }
                }
            );
			//M1A1 Mine
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Dynamite"),
                    NameOverride = "M1A1 Mine [CWWM]",
                    NameToOrderByOverride = "a",
                    DescriptionOverride = "An American anti-tank mine. Won't trigger under light pressure." + "\n<color=green>World War II (1942)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/m1a1.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("america/m1a1.png");
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Flammable metal");
						Instance.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 2f;
						Instance.GetComponent<ExplosiveBehaviour>().ArmOnUse = false;
						Instance.FixColliders();
                    }
                }
            );
			//M1 Garand
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "M1 Garand [CWWM]",
                    NameToOrderByOverride = "a",
                    DescriptionOverride = "An American semi-automatic rifle." + "\n<color=green>World War II (1936)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/garand.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("america/garand.png");
						Instance.FixColliders();
                          var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/garand.wav")
                        };
                    }
                }
            );
			//Browning M2HB
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Light Machine Gun"),
                    NameOverride = "Browning M2HB [CWWM]",
                    NameToOrderByOverride = "a",
                    DescriptionOverride = "An American heavy machine gun." + "\n<color=green>World War II (1933)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/browning.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("america/browning.png");
						Instance.FixColliders();
						var firearm = Instance.GetComponent<FirearmBehaviour>();

						firearm.AutomaticFireInterval = 0.12f;
						firearm.InitialInaccuracy = 0.05f;
                    }
                }
            );
			//M1928 Thompson
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Soviet Submachine Gun"),
                    NameOverride = "M1928 Thompson [CWWM]",
                    NameToOrderByOverride = "a",
                    DescriptionOverride = "An American submachine gun." + "\n<color=green>World War II (1928)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/thompson.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("america/thompson.png");
						Instance.FixColliders();
                    }
                }
            );
			//Colt M1911
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "Colt M1911 [CWWM]",
                    NameToOrderByOverride = "a",
                    DescriptionOverride = "An American semi-automatic pistol." + "\n<color=purple>WW1 & WW2 (1911)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/m1911.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("america/m1911.png");
						Instance.FixColliders();
                          var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/m1911.wav")
                        };
                    }
                }
            );
			//FP-45 Liberator
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "FP-45 Liberator [CWWM]",
                    NameToOrderByOverride = "a",
                    DescriptionOverride = "An American single-shot pistol." + "\n<color=green>World War II (1942)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/fp45.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("america/fp45.png");
						Instance.FixColliders();
                          var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("sfx/welrod.wav")
                        };
                    }
                }
            );
			//Mk.II Grenade
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                    NameOverride = "Mk.II Grenade [CWWM]",
                    NameToOrderByOverride = "a",
                    DescriptionOverride = "An American anti-personnel hand grenade." + "\n<color=green>World War II (1918)",
                    CategoryOverride = ModAPI.FindCategory("Cyber's World War Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("preview/mkii.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("america/mkii.png");
						Instance.FixColliders();
                    }
                }
            );
        }
    }
}
public class RandomHumanTextureBehaviour : MonoBehaviour
{
    private void Start()
    {
        this.phys = gameObject.GetComponent<PhysicalBehaviour>();
        chosenIndex = UnityEngine.Random.Range(0, Textures.Count - 0);
        NextTexture();
        phys.ContextMenuOptions.Buttons.Add(menuButton = new ContextMenuButton("NextTexture", "Next texture", "Switches to the next texture", new UnityAction[1]
        {
            (UnityAction) (() =>
            {
                NextTexture();
                foreach (var limb in person.Limbs)
                {
                    if (limb.GetComponent<RandomHumanTextureBehaviour>())
                    {
                        limb.GetComponent<RandomHumanTextureBehaviour>().chosenIndex = chosenIndex;
                    }
                }
            })
        }));
        phys.ContextMenuOptions.Buttons.Add(menuButton = new ContextMenuButton("PreviousTexture", "Previous texture", "Switches to the previous texture", new UnityAction[1]
        {
            (UnityAction) (() =>
            {
                PreviousTexture();
                foreach (var limb in person.Limbs)
                {
                    if (limb.GetComponent<RandomHumanTextureBehaviour>())
                    {
                        limb.GetComponent<RandomHumanTextureBehaviour>().chosenIndex = chosenIndex;
                    }
                }
            })
        }));
    }
    private void NextTexture()
    {
        chosenIndex += 1;
        if (chosenIndex > Textures.Count - 1)
        {
            chosenIndex = 0;
        }
        person.SetBodyTextures(Textures[chosenIndex]);
    }
    private void PreviousTexture()
    {
        chosenIndex -= 1;
        if (chosenIndex < 0)
        {
            chosenIndex = Textures.Count - 1;
        }
        person.SetBodyTextures(Textures[chosenIndex]);
    }

   public List<Texture2D> Textures = new List<Texture2D>();
   public int chosenIndex = -1;
   public PersonBehaviour person;
   private PhysicalBehaviour phys;
   private ContextMenuButton menuButton;
}

///Made By CyberPlays26